// MBDoc.cpp : implementation of the CMBDoc class
//

#include "stdafx.h"
#include "Moebius.h"

#include "MBDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMBDoc

IMPLEMENT_DYNCREATE(CMBDoc, CDocument)

BEGIN_MESSAGE_MAP(CMBDoc, CDocument)
	ON_COMMAND(ID_ANIMATION_STOP, OnAnimationStop)
	ON_COMMAND(ID_ANIMATION_PLAY, OnAnimationPlay)
	ON_UPDATE_COMMAND_UI(ID_ANIMATION_STOP, OnUpdateAnimationStop)
	ON_UPDATE_COMMAND_UI(ID_ANIMATION_PLAY, OnUpdateAnimationPlay)
END_MESSAGE_MAP()


// CMBDoc construction/destruction

CMBDoc::CMBDoc()
{
LastClock=0;
ElapsedSec=0;
}

CMBDoc::~CMBDoc()
{
}

BOOL CMBDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	q2mA.Load("data/priss/tris.md2","data/priss/prissmesh.pcx");
  q2mA.SetAnim(40,45);
	q2mA.SetFPS(4);
	
	q2mB.Load("data/alita/tris.md2","data/alita/alita4.pcx");
  q2mB.SetAnim(40,45);
	q2mB.SetFPS(4);

	q2mC.Load("data/walker/tris.md2","data/walker/baseskin.pcx");
  q2mC.SetAnim(40,45);
	q2mC.SetFPS(4);

	m_bplay=true;
	ElapsedSec=0;
	//mod3ds.LoadFile("data/futurecar2.3ds");
	//mod3ds.LoadFile("data/redcycle.3ds");
	
	//model_name="data/terminator/tris.md2";
	//tex_name  ="data/terminator/blood.pcx";

	//model_name="data/alita/tris.md2";
	//tex_name  ="data/alita/alita4.pcx";

	RollingSphereRadius=.5f;
	CIShape::Sphere(RollingSphere,RollingSphereRadius,20,40);
	
	Scene.root.Sons.push_back(new CSGAnimZPrecession());
	MoebiusStrip *ms=new MoebiusStrip();
	ms->Generate();
	Scene.root.Sons.push_back(ms);
	
	return TRUE;
}




// CMBDoc serialization

void CMBDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


// CMBDoc diagnostics

#ifdef _DEBUG
void CMBDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMBDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CMBDoc commands

void CMBDoc::OnAnimationStop()
{
	m_bplay=false;
}

void CMBDoc::OnAnimationPlay()
{
	m_bplay=true;
}

void CMBDoc::OnUpdateAnimationStop(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_bplay);
}

void CMBDoc::OnUpdateAnimationPlay(CCmdUI *pCmdUI)
{
pCmdUI->Enable(!m_bplay);
}

BOOL CMBDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;

	// TODO:  Add your specialized creation code here

	return TRUE;
}

BOOL CMBDoc::OnSaveDocument(LPCTSTR lpszPathName)
{
	FILE *fp=fopen(lpszPathName,"w");
	if(!fp) return FALSE;

	Scene.root.XMLWrite(fp);	// TODO: Add your specialized code here and/or call the base class
	fclose(fp);
	return TRUE;
}
