#pragma once
#include <list>
#include <vcg/xml/xml.h>
#include <vcg/Matrix44.h>
#include <vcg/xml/xmlUtility.h>

using namespace std;
namespace vcg {


class CSGNode 
{
public:
	virtual	~CSGNode(void){};
	
	virtual void glDraw(const float DocTime)=0;
	virtual void XMLWrite(FILE *fp)=0;
	//virtual void XMLRead(FILE *fp)=0;
};

class CSGGroup :public CSGNode 
{
	public:
  virtual ~CSGGroup();
	typedef list<CSGNode *>::iterator iterator;
  
  
	list<CSGNode *> Sons;
	virtual void glDraw(const float DocTime);
  virtual void XMLWrite(FILE *fp);
//	virtual void XMLRead(Xml &xml);
};

class CSGTransformation :public CSGNode 
{
	public:
  Matrix44f m;
	virtual void glDraw(const float DocTime);
	virtual void XMLWrite(FILE *fp);
	//virtual void XMLRead(Xml &xml);
};

class CSGAnimRotation :public CSGNode 
{
	public:
  Point3f axis;
	float AngularSpeedDPS; //Degree Per Sec;
  float StartAngleDeg; 
	virtual void glDraw(const float DocTime);
	virtual void XMLWrite(FILE *fp);
	//virtual void XMLRead(Xml &xml);
};

class CSGAnimZPrecession :public CSGNode 
{
	public:
  CSGAnimZPrecession();
 
  float DeclinationDeg;
	float AngularSpeedDPS; //Degree Per Sec;
  float StartAngleDeg; 
	virtual ~CSGAnimZPrecession(){};
	virtual void glDraw(const float DocTime);
  virtual void XMLWrite(FILE *fp);
//	virtual void XMLRead(Xml &xml);
};



// Minimal Scene graph
// Solo i gruppi definiscono uno scope di trasformazioni
// l'ordine dei figli  significativo.
class CSG
{
public:
	CSG(void);
	~CSG(void);
	CSGGroup root;
};


} // end namespace